# frozen_string_literal: true

require './lib/storage/algolia/base'

module Storage
  module Algolia
    module Actions
      class All < ::Storage::Algolia::Base
        attr_reader :model_name, :cursor

        def initialize(model_name:, cursor: nil)
          @model_name = model_name
          @cursor = cursor
        end

        def process
          normalize query.dig('hits')
        end

        def meta
          query.except!('hits').to_hashugar
        end

        private

        def query
          @query ||= index.browse({ cursor: cursor })
        end
      end
    end
  end
end
