# frozen_string_literal: true

require './lib/storage/algolia/base'

module Storage
  module Algolia
    module Actions
      class Delete < ::Storage::Algolia::Base
        MAX_RETRIES = 3

        attr_reader :model_name, :id, :retries

        def initialize(model_name:, id:)
          @model_name = model_name
          @id = id
          @retries = 0
        end

        def process
          index.delete_object(original_object.id)
        end

        private

        def original_object
          @original_object ||= ::Storage::Algolia::Actions::Get.process(
            model_name: model_name,
            id: id
          )
        end
      end
    end
  end
end