# frozen_string_literal: true

require './lib/storage/algolia/base'

module Storage
  module Algolia
    module Actions
      class Get < ::Storage::Algolia::Base
        MAX_RETRIES = 3

        attr_reader :model_name, :id, :retries

        def initialize(model_name:, id:)
          @model_name = model_name
          @id = id
          @retries = 0
        end

        def process
          @retries += 1
          normalize index.get_object(id).deep_transform_keys(&:to_sym)
        rescue => e
          pp "Retrying (#{@retries}/#{MAX_RETRIES})..."
          sleep 2
          retry if @retries <= MAX_RETRIES
          raise Exception
        end
      end
    end
  end
end
