# frozen_string_literal: true

module Storage
  module Algolia
    def self.all(model_name:, cursor: nil)
      ::Storage::Algolia::Actions::All.new(
        model_name: model_name,
        cursor: cursor
      )
    end

    def self.get(model_name:, id:)
      ::Storage::Algolia::Actions::Get.process(
        model_name: model_name,
        id: id
      )
    end

    def self.create(model_name:, params:)
      ::Storage::Algolia::Actions::Create.process(
        model_name: model_name,
        params: params
      )
    end

    def self.update(model_name:, params:, id:)
      ::Storage::Algolia::Actions::Update.process(
        model_name: model_name,
        params: params,
        id: id
      )
    end

    def self.delete(model_name:, id:)
      ::Storage::Algolia::Actions::Delete.process(
        model_name: model_name,
        id: id
      )
    end

    def self.clear(model_name:)
      ::Storage::Algolia::Index::Clear.process(
        model_name: model_name
      )
    end
  end
end

