# frozen_string_literal: true

require './lib/storage/application_service'

module Algolia
  class NormalizeId < ::ApplicationService
    attr_reader :data

    def initialize(data)
      @data = data
    end

    def process
      data.kind_of?(Array) ?
        data.map { |node| objectid_to_id(node) }.to_hashugar :
        objectid_to_id(data)
    end

    private

    def objectid_to_id(node)
      node[:id] = node.delete(:objectID)
      node.to_hashugar
    end
  end
end
